comment #
*************************************************
*						*
* PGAL operation test program *
* *
* IBM PC / PC98 automatic correspondence *
* *
* 1995.7.14 first edition *
* 1997.7.10 GAL22V10 supported *
*						*
*************************************************

To re-assemble necessary OPTASM.
>optasm xgal; /ml

#

include	stddef.inc
include	str.inc
include	file.inc
include	ibmpc.inc


.model t
.186
;-----------------------------------------------------------------------------
; The definition of the data area

.data

MessOpn		db	'PGALCHK - PGAL function check program',CR,LF,LF
		db	'Machine type = $'
MesPC		db	'IBM PC (LPT1)$'
MesP9		db	'NEC PC98$'

MesGr	db	CR,LF,LF
	db	'P/U Vpp Vcc                             Input       Ctrl-S  cursor left',CR,LF
	db	'| | | | | |                              | |        Ctrl-D  cursor right',CR,LF
	db	'15| 2 | 24| 9   7   5   3   21  10  13   15|        Space   output inversion ',CR,LF
	db	'| 14| 4 | 22| 8 | 6 | 4 | 20| 22| 11|    | 14       Enter   timer test',CR,LF
	db	'| | | | | | | | | | | | | | | | | | |    | |        Esc     Exit',CR,LF
	db	'$'

MessTim	db	CR,LF,LF,'timer test:   $'


S_DAT		equ	BIT0	; Bit allocation of the output port
S_CLK		equ	BIT1	;
S_STB		equ	BIT2	;
T_TRG		equ	BIT3	;
G_CLK		equ	BIT4	;
G_DAT		equ	BIT5	;
G_STB		equ	BIT6	;

CtrlPort	dw	?	; Address of the parallel port
PortReg	db	?	;                data

				;     16V8   20V8   22V10
				; bit -----  -----  -----
Ctrl1		db	?	; b0: "1"    P/V    "0"     (U1-15)
				; b1: P/V    RA0    "0"     (U1-1)
				; b2: RA0    "0"    "0"     (U1-2)
				; b3: "0"    RA1    P/V     (U1-3)
				; b4: "0"    RA2    COM0    (U1-4)
				; b5: RA1    RA3    COM1    (U1-5)
				; b6: RA2    "0"    COM2    (U1-6)
				; b7: RA3    "0"    COM3    (U1-7)

Ctrl2		db	?	; b0: RA4    RA4    COM4    (U2-15)
				; b1: RA5    RA5    COM5    (U2-1)
				; b2: /VCC   "1"    "1"     (U2-2)
				; b3: "1"    /VCC   /VCC    (U2-3)
				; b4: /VPP   "1"    "1"     (U2-4)
				; b5: "1"    /VPP   /VPP    (U2-5)
				; b6: "1"    "0"    "1"     (U2-6)
				; b7: "0"    "1"    "0"     (U2-7)

BitPtr		db	?	; Operation bit position (0..15,16..18)




;-----------------------------------------------------------------------------
; Program code
;-----------------------------------------------------------------------------

.code
		DEF_PSP
start:
		cld
		 call	INITIAL		; GAL writer initialization

		mov	BitPtr,0
	_while
		 call	SET_REG
		 call	DISP
		$DOS  7
	 _break e, al,CR	; Enter
	 _break e, al,ESC	; Esc
	 _case e, al,4		; ?
		inc	BitPtr
	  _if a, BitPtr,18
		mov	BitPtr,18
	  _endif
	 _case e, al,19		; ?
		dec	BitPtr
	  _if l, BitPtr,0
		mov	BitPtr,0
	  _endif
	 _case e, al,' '	; Space
		mov	cl,BitPtr
	  _if a, cl,15
		sub	cl,16
		mov	al,BIT4
		shl	al,cl
		xor	PortReg,al
	  _else
		mov	ax,BIT15
		shr	ax,cl
		xor	wptr Ctrl1,ax
	  _endif
	 _endc
	_rept

	_skip e, al,ESC
		PRINT  MessTim
		mov	bx,0
	 _while
		 call	DSP_N
		 call	DLY10
		inc	bx
	 _rept b, bx,1000
	_endif
		$DOS  4ch,0


DISP		proc
		mov	dl,CR
		$DOS  6
		mov	bp,19
		 call	dsp_out
		clr	ax
		mov	al,BitPtr
		mov	bp,ax
		 call	dsp_out
		ret
dsp_out:
		mov	bx,BIT15
	_repeat 16
		ret e, bp,0
		dec	bp
		test	wptr Ctrl1,bx
		mov	dx,'HL'
	 @ifn z,<xchg	dh,dl>
		test	bx,BIT13+BIT12+BIT11+BIT10
	 @ifn z,<xchg	dh,dl>
		$DOS  6
		mov	dl,' '
		$DOS  6
		shr	bx,1
	_loop
		mov	bl,BIT4
	_repeat 3
		ret e, bp,0
		dec	bp
		test	PortReg,bl
		mov	dl,'L'
	 @ifn z,<mov	dl,'H'>
		$DOS  6
		mov	dl,' '
		$DOS  6
		shl	bl,1
	_loop
		$DOS  6
		$DOS  6
		$DOS  6
		 call	READ_BIT
		shr	bl,1
		mov	dl,'L'
	 @if c,<mov	dl,'H'>
		$DOS  6
		mov	dl,' '
		$DOS  6
		shr	bl,1
		mov	dl,'L'
	 @if c,<mov	dl,'H'>
		$DOS  6
		mov	dl,CR
		$DOS  6
		ret
DISP		endp


DSP_N		proc
	_repeat 3
		mov	dl,BS
		$DOS  6
	_loop
		mov	ax,bx
	_repeat 3
		mov	si,10
		clr	dx
		div	si
		push	dx
	_loop
	_repeat 3
		pop	dx
		add	dl,'0'
		$DOS  6
	_loop
		ret
DSP_N		endp



INITIAL		proc
		PRINT  MessOpn		; startup message
		movseg	es,SEG_BIOS
		mov	ax,es:BiosLptLst[0]
		movseg	es,cs
	_skip e, ax,3bch
	 _skip e, ax,378h
	  _skip e, ax,278h
		mov	ax,40h
	___endif
		mov	CtrlPort,ax
	_if ne
		PRINT  MesP9
	_else
		PRINT  MesPC
	_endif
		PRINT  MesGr
		mov	PortReg,0
		mov	Ctrl1,00000000b
		mov	Ctrl2,00111100b
		 call	SET_REG
		ret
INITIAL		endp



;--------------------------------------;
; GAL output reading
;
; Ret	AL = b0:#15, b1:#14

READ_BIT	proc
		push	dx
		clr	bl
		res	PortReg,S_DAT+S_CLK
		outb	CtrlPort,PortReg
		 call	rb1
		shl	bl,1
		set	PortReg,S_DAT
		outb	CtrlPort,PortReg
		 call	rb1
		pop	dx
		ret
rb1:
	_if ne, dx,40h		; IBMPC
		inc	dx
		in	al,dx
		test	al,BIT7
	_else			; PC98
		incw	dx
		in	al,dx
		test	al,BIT2
	_endif
	@if z, <set	bl,BIT0>
		ret
READ_BIT	endp


;--------------------------------------;
; Setting of XGAL of the shift register
;
;  Ctrl1, and set the value of the Ctrl2

SET_REG		proc
		push	ax,bx,cx,dx
		mov	dx,CtrlPort
		mov	al,PortReg
		mov	bh,Ctrl2	; send U1/U2 data
		mov	bl,Ctrl1
	_repeat 16
		res	al,S_DAT+S_CLK
		shl	bx,1
	 @if c,<set	al,S_DAT>
		out	dx,al
		set	al,S_CLK
		out	dx,al
	_loop
		set	al,S_STB	; STB
		out	dx,al		;
		res	al,S_STB	;
		out	dx,al		;
		mov	PortReg,al
		pop	dx,cx,bx,ax
		ret
SET_REG		endp


;--------------------------------------;
; 10 ms waiting

DLY10		proc
		push	ax,dx
		set	PortReg,T_TRG+S_CLK	; trigger timer
		outb	CtrlPort,PortReg
		res	PortReg,T_TRG+S_DAT
		outb	CtrlPort,PortReg

	_if ne, dx,40h		; IBMPC
		inc	dx
		mov	ah,BIT7
	_else			; PC98
		mov	dx,42h
		mov	ah,BIT2
	_endif
	_while
		in	al,dx
	_rept z,<test	al,ah>
		pop	dx,ax
		ret
DLY10		endp


;--------------------------------------;

		$end	start

